// TestWinDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestWin.h"
#include "TestWinDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "WUSBdrv.h"

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestWinDlg dialog

CTestWinDlg::CTestWinDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestWinDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestWinDlg)
	m_iomask = 0;
	m_read = 0;
	m_write = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestWinDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestWinDlg)
	DDX_Text(pDX, IDC_IOMASK, m_iomask);
	DDX_Text(pDX, IDC_READ, m_read);
	DDX_Text(pDX, IDC_WRITE, m_write);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestWinDlg, CDialog)
	//{{AFX_MSG_MAP(CTestWinDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnOpen)
	ON_BN_CLICKED(IDC_BUTTON2, OnSetup)
	ON_BN_CLICKED(IDC_BUTTON3, OnWrite)
	ON_BN_CLICKED(IDC_BUTTON4, OnRead)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestWinDlg message handlers

BOOL CTestWinDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestWinDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestWinDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestWinDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTestWinDlg::OnOpen() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);

	int status = WUSB_Open();
	if(status == WUSB_ERROR)
	{		
		MessageBox("ERROR! Can`t open WodmanUSB device", "Info", MB_ICONERROR);		
	}
	else
	{
		MessageBox("Open OK", "Info", MB_ICONINFORMATION);		
	}	

	
}

void CTestWinDlg::OnSetup() 
{
	// TODO: Add your control notification handler code here	
	UpdateData(true);

	if(m_iomask < 0 || m_iomask > 255)
	{
		MessageBox("Bad IO_Mask value", "Info", MB_ICONERROR);
		return;
	}

	WUSB_SetupPortA(m_iomask);	

	MessageBox("IOMask was sucsesfully set", "Info", MB_ICONINFORMATION);	
}

void CTestWinDlg::OnWrite() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);

	if(m_write < 0 || m_write > 255)
	{
		MessageBox("Bad Write Data value", "Info", MB_ICONERROR);
		return;
	}

	WUSB_WritePortA(m_write);	
}

void CTestWinDlg::OnRead() 
{
	// TODO: Add your control notification handler code here
	unsigned char byte = 0; 
	WUSB_ReadPortA(&byte);

	m_read = byte;
	UpdateData(false);
}
